#include <cstdio>

long long int Q,N,a[200000],z[200000][2],s;

int main()
{
    scanf("%lld %lld",&N,&Q);
    for(long long int i=0;i<N;i++)
        scanf("%lld",&a[i]);
    for(long long int i=0;i<Q;i++)
        scanf("%lld %lld",&z[i][0],&z[i][1]);
    for(long long int i=0;i<Q;i++)
    {
        s=a[z[i][0]-1]&a[z[i][0]];
        for(long long int j=z[i][0]+1;j<z[i][1];j++)
            s=s&a[j];
        printf("%lld\n",s);
    }
    return 0;
}